//this file is part of eMule
//Copyright (C)2002 Merkur ( devs@emule-project.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#pragma once
#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif
#include ".\Optimizer\cpu_info.h" // [ionix] - Optimizer
#include "resource.h"
#include "log.h"
#include ".\MiniMule\TBHMM.h" // [ionix] - TBH: minimule
#include "BandwidthControl.h" //Pawcio::BC
//new upnp - disabled
//#include "UPnP_IGDControlPoint.h" // [ionix] [MoNKi: -UPnPNAT Support-]
#include "UPnPNat.h" // [ionix] [MoNKi: -UPnPNAT Support-]
#include "./MiniMule/Sysinfo.h" //>>> SysInfo
//new upnp - disabled
#ifdef SPOOKY
#include "ConChecker.h" //>>> WiZaRd: Spooky Mode ConChecker Addon 
#endif

//#define	DEFAULT_NICK		(GetModIdVersion()) // modified by [ionix]
#define	DEFAULT_TCP_PORT	4662
#define	DEFAULT_UDP_PORT	(DEFAULT_TCP_PORT+10)

#define PORTTESTURL			_T("http://porttest.emule-project.net/connectiontest.php?tcpport=%i&udpport=%i&lang=%i")

class CSearchList;
class CUploadQueue;
class CListenSocket;
class CDownloadQueue;
class CScheduler;
class UploadBandwidthThrottler;
class DownloadBandwidthThrottler; // Pawcio: BC Download
class LastCommonRouteFinder;
class CemuleDlg;
class CClientList;
class CKnownFileList;
class CServerConnect;
class CServerList;
class CSharedFileList;
class CClientCreditsList;
class CFriendList;
class CClientUDPSocket;
class CIPFilter;
class CWebServer;
class CMMServer;
class CAbstractFile;
class CUpDownClient;
class CPeerCacheFinder;
class CFirewallOpener;
class CIP2Country; //EastShare - added by [ionix], IP to Country
class CFakecheck; // [TPT] - Fakecheck

struct SLogItem;

#include "PPgBobo2.h" //[ionix] -, TBH-AutoBackup

enum AppState{
	APP_STATE_RUNNING=0,
   	APP_STATE_SHUTINGDOWN,
	APP_STATE_DONE
};

class CemuleApp : public CWinApp
{
	friend class CTBHMM; // [ionix] - TBH: minimule

public:
	CemuleApp(LPCTSTR lpszAppName = NULL);	
	bool	InitAppLog();
#ifdef SPOOKY
	WombatAgent::CConChecker    conchecker; //>>> WiZaRd: Spooky Mode ConChecker Addon 
	void	InitConChecker(void);
#endif
	BOOL	InitSockets(void);


	CPUInfo 			cpu; 		// [ionix] - Optimizer


	// ZZ:UploadSpeedSense -->
    UploadBandwidthThrottler* uploadBandwidthThrottler;
    LastCommonRouteFinder* lastCommonRouteFinder;
	// ZZ:UploadSpeedSense <--
	DownloadBandwidthThrottler* downloadBandwidthThrottler; // Pawcio: BC Download
	CemuleDlg*			emuledlg;
	CClientList*		clientlist;
	CKnownFileList*		knownfiles;
	CServerConnect*		serverconnect;
	CServerList*		serverlist;	
	CSharedFileList*	sharedfiles;
	CSearchList*		searchlist;
	CListenSocket*		listensocket;
	CUploadQueue*		uploadqueue;
	CDownloadQueue*		downloadqueue;
	CClientCreditsList*	clientcredits;
	CFriendList*		friendlist;
	CClientUDPSocket*	clientudp;
	CIPFilter*			ipfilter;
	CWebServer*			webserver;
	CScheduler*			scheduler;
	CMMServer*			mmserver;
	CPeerCacheFinder*	m_pPeerCache;
	CFirewallOpener*	m_pFirewallOpener;
	CTBHMM*				minimule; // [ionix] - TBH: minimule
	CSysInfo*               sysinfo; //>>> SysInf

	CBandwidthControl*	BC; //Pawcio: BC

	CFakecheck*			FakeCheck; // [TPT] - Fakecheck
	CPPgBobo2*			PPgBobo2; //[ionix] -, TBH-AutoBackup
	CIP2Country*		ip2country; //EastShare - added by [ionix], IP to Country

	//HANDLE				m_hMutexOneInstance;  	// >>> [iONiX] - WiZaRd - Multiple Instances

	int					m_iDfltImageListColorFlags;
	CFont				m_fontHyperText;
	CFont				m_fontDefaultBold;
	CFont				m_fontSymbol;
	CFont				m_fontLog;
	CBrush				m_brushBackwardDiagonal;
	static const UINT	m_nVersionMjr;
	static const UINT	m_nVersionMin;
	static const UINT	m_nVersionUpd;
	static const UINT	m_nVersionBld;
	DWORD				m_dwProductVersionMS;
	DWORD				m_dwProductVersionLS;
	CString				m_strCurVersionLong;
	UINT				m_uCurVersionShort;
	UINT				m_uCurVersionCheck;
	ULONGLONG			m_ullComCtrlVer;
	AppState			m_app_state; // defines application state for shutdown 
	BOOL				m_reset_app; // [iONiX] - WiZaRd - Multiple Instances
	CMutex				hashing_mut;
	CString*			pendinglink;
	COPYDATASTRUCT		sendstruct;

// Implementierung
	virtual BOOL InitInstance();
	virtual int ExitInstance();

	// ed2k link functions
	void		AddEd2kLinksToDownload(CString strLinks, uint8 cat);
	void		SearchClipboard();
	void		IgnoreClipboardLinks(CString strLinks) {m_strLastClipboardContents = strLinks;}
	void		PasteClipboard(uint8 uCategory = 0);
	bool		IsEd2kFileLinkInClipboard();
	bool		IsEd2kServerLinkInClipboard();
	bool		IsEd2kLinkInClipboard(LPCSTR pszLinkType, int iLinkTypeLen);
	LPCTSTR		GetProfileFile()		{ return m_pszProfileName; }

	CString		CreateED2kSourceLink(const CAbstractFile* f);
//	CString		CreateED2kHostnameSourceLink(const CAbstractFile* f);
	CString		CreateKadSourceLink(const CAbstractFile* f);

	// clipboard (text)
	bool		CopyTextToClipboard(CString strText);
	CString		CopyTextFromClipboard();

	void		OnlineSig();
	void		UpdateReceivedBytes(uint32 bytesToAdd);
	void		UpdateSentBytes(uint32 bytesToAdd, bool sentToFriend = false);
	int			GetFileTypeSystemImageIdx(LPCTSTR pszFilePath, int iLength = -1);
	HIMAGELIST	GetSystemImageList() { return m_hSystemImageList; }
	CSize		GetSmallSytemIconSize() { return m_sizSmallSystemIcon; }
	void		CreateBackwardDiagonalBrush();
	void		CreateAllFonts();
	bool		IsPortchangeAllowed();
//>>> Fenderman - Spooky Mode [eWombat] 
	/*
	bool		IsConnected();
	*/
#ifdef SPOOKY 
    bool        IsConnected(bool bIncludeSpooky=true); 
    bool        IsOnlySpooky(); 
#else 
	bool		IsConnected();
#endif 
//<<< Fenderman - Spooky Mode [eWombat] 
	bool		IsFirewalled();
	bool		DoCallback( CUpDownClient *client );
	uint32		GetID();
	uint32		GetPublicIP() const;	// return current (valid) public IP or 0 if unknown
	void		SetPublicIP(const uint32 dwIP);

	// because nearly all icons we are loading are 16x16, the default size is specified as 16 and not as 32 nor LR_DEFAULTSIZE
	HICON		LoadIcon(LPCTSTR lpszResourceName, int cx = 16, int cy = 16, UINT uFlags = LR_DEFAULTCOLOR) const;
	HICON		LoadIcon(UINT nIDResource) const;
	HBITMAP		LoadImage(LPCTSTR lpszResourceName, LPCTSTR pszResourceType) const;
	HBITMAP		LoadImage(UINT nIDResource, LPCTSTR pszResourceType) const;
	bool		LoadSkinColor(LPCTSTR pszKey, COLORREF& crColor) const;
	bool		LoadSkinColorAlt(LPCTSTR pszKey, LPCTSTR pszAlternateKey, COLORREF& crColor) const;
	CString		GetSkinFileItem(LPCTSTR lpszResourceName, LPCTSTR pszResourceType) const;
	void		ApplySkin(LPCTSTR pszSkinProfile);
	void		EnableRTLWindowsLayout();
	void		DisableRTLWindowsLayout();

	bool		GetLangHelpFilePath(CString& strResult);
	void		SetHelpFilePath(LPCTSTR pszHelpFilePath);
	void		ShowHelp(UINT uTopic, UINT uCmd = HELP_CONTEXT);
	bool		ShowWebHelp();

    // Elandal:ThreadSafeLogging -->
    // thread safe log calls
    void			QueueDebugLogLine(bool bAddToStatusBar, LPCTSTR line,...);
    void			QueueDebugLogLineEx(UINT uFlags, LPCTSTR line,...);
    void			HandleDebugLogQueue();
    void			ClearDebugLogQueue(bool bDebugPendingMsgs = false);

	void			QueueLogLine(bool bAddToStatusBar, LPCTSTR line,...);
    void			QueueLogLineEx(UINT uFlags, LPCTSTR line,...);
    void			HandleLogQueue();
    void			ClearLogQueue(bool bDebugPendingMsgs = false);
    // Elandal:ThreadSafeLogging <--

	bool			DidWeAutoStart() { return m_bAutoStart; }

protected:
	bool ProcessCommandline();
	void SetTimeOnTransfer();
	#define MAGIC		0xafecffbd // <<< [iONiX] - WiZaRd - Multiple Instances
	static BOOL CALLBACK SearchEmuleWindow(HWND hWnd, LPARAM lParam);
	bool	m_bWinSock2;
	DECLARE_MESSAGE_MAP()
	afx_msg void OnHelp();

	HIMAGELIST m_hSystemImageList;
	CMapStringToPtr m_aExtToSysImgIdx;
	CSize m_sizSmallSystemIcon;

	bool		m_bGuardClipboardPrompt;
	CString		m_strLastClipboardContents;

    // Elandal:ThreadSafeLogging -->
    // thread safe log calls
    CCriticalSection m_queueLock;
    CTypedPtrList<CPtrList, SLogItem*> m_QueueDebugLog;
    CTypedPtrList<CPtrList, SLogItem*> m_QueueLog;
    // Elandal:ThreadSafeLogging <--

	uint32 m_dwPublicIP;
	bool m_bAutoStart;
public:
	void OptimizerInfo(void); // [ionix] - Optimizer
	bool WinSock2() {return m_bWinSock2;}
	WSADATA				m_wsaData; //eWombat [WINSOCK2]

	// [ionix] [MoNKi: -UPnPNAT Support-]
//new upnp - disabled
/*
	CUPnP_IGDControlPoint *m_UPnPNat;
	BOOL		AddUPnPNatPort(CUPnP_IGDControlPoint::UPNPNAT_MAPPING *mapping);
	BOOL		RemoveUPnPNatPort(CUPnP_IGDControlPoint::UPNPNAT_MAPPING *mapping);
*/
	CUPnPNat	m_UPnPNat;
	BOOL		AddUPnPNatPort(CUPnPNat::UPNPNAT_MAPPING *mapping, bool tryRandom = false);
	BOOL		RemoveUPnPNatPort(CUPnPNat::UPNPNAT_MAPPING *mapping);
//new upnp - disabled
	// [ionix] [MoNKi: -UPnPNAT Support-]

	uint32        GetConnectionState()					{return m_nConnectionState;} 
    void          SetConnectionState(uint32 state)		{m_nConnectionState=state;} 

// MORPH START - Added by [ionix], Friendlinks [emulEspaa]
	public:
		bool	IsEd2kFriendLinkInClipboard();
// [ionix] Friendlinks [emulEspaa]
	private:
		uint32          m_nConnectionState;
};

extern CemuleApp theApp;


//////////////////////////////////////////////////////////////////////////////
// CTempIconLoader

class CTempIconLoader
{
public:
	// because nearly all icons we are loading are 16x16, the default size is specified as 16 and not as 32 nor LR_DEFAULTSIZE
	CTempIconLoader(LPCTSTR pszResourceID, int cx = 16, int cy = 16, UINT uFlags = LR_DEFAULTCOLOR);
	CTempIconLoader(UINT uResourceID, int cx = 16, int cy = 16, UINT uFlags = LR_DEFAULTCOLOR);
	~CTempIconLoader();

	operator HICON() const{
		return this == NULL ? NULL : m_hIcon;
	}

protected:
	HICON m_hIcon;
};
